local addonName, a = ...
local L = a.Localize
local s = SpellFlashAddon
local c = BittensGlobalTables.GetTable("BittensSpellFlashLibrary")

local GetPowerRegen = GetPowerRegen
local GetTime = GetTime
local UnitInRange = UnitInRange
local UnitIsDeadOrGhost = UnitIsDeadOrGhost
local UnitIsUnit = UnitIsUnit
local select = select
local string = string
local tostring = tostring

a.Rotations = {}

a.LastRapture = 0
a.ShieldSeen = 0

local function setHealingNeeded()
	for unit in c.GetGroupMembers() do
		if s.HealthPercent(unit) < c.GetOption("HealPercent")
			and (UnitInRange(unit) or UnitIsUnit(unit, "player"))
			and not UnitIsDeadOrGhost(unit) then
			
			a.HealingNeeded = true
			return
		end
	end
	a.HealingNeeded = false
end

a.Rotations.Atonement = {
	Spec = 1,
	
	UsefulStats = { "Intellect", "Spirit", "Crit", "Haste" },
	
	FlashInCombat = function()
		setHealingNeeded()
		a.Mana = 
			100 * c.GetPower(select(2, GetPowerRegen())) / s.MaxPower("player")
		a.Conserve = a.Mana < c.GetOption("ConservePercent")
		a.Neutral = a.Mana < c.GetOption("NeutralPercent")
		a.OnlyHeal = a.Mana < c.GetOption("OnlyHealPercent")
		if s.MyBuff(c.GetID("Power Word: Shield"), a.ShieldTarget) then
			a.ShieldSeen = GetTime()
		end
		
		c.FlashAll(
			"Shadowfiend", 
			"Mindbender", 
			"Power Word: Shield", 
			"Desperate Prayer", 
			"Dispel Magic")
		if not a.HealingNeeded and a.OnlyHeal and not c.IsSolo() then
			c.PriorityFlash("Power Word: Solace")
		elseif a.Conserve then
			if not a.Neutral then
				c.FlashAll("Power Infusion")
			end
			c.DelayPriorityFlash(
				"Penance",
				"Power Word: Solace",
				"Holy Fire",
				"Shadow Word: Death",
				"Shadow Word: Pain Refresh",
				"Divine Star",
				"Smite")
		else
			c.FlashAll("Power Infusion")
			c.PriorityFlash(
				"Penance",
				"Shadow Word: Pain Apply",
				"Divine Star",
				"Shadow Word: Death",
				"Power Word: Solace",
				"Holy Fire",
				"Shadow Word: Pain Refresh",
				"Smite")
		end
	end,
	
	MovementFallthrough = function() 
		c.PriorityFlash("Cascade")
	end,
	
	FlashAlways = function()
		c.FlashAll("Power Word: Fortitude", "Inner Fire")
	end,
	
	CastSucceeded = function(info)
		if c.InfoMatches(info, "Power Word: Shield") then
			a.ShieldTarget = info.Target
			c.Debug("Event", "PW:S on", a.ShieldTarget)
		end
	end,
	
	Energized = function(spellID)
		if c.IdMatches(spellID, "Rapture") then
			a.LastRapture = GetTime()
			a.ShieldSeen = 0
			c.Debug("Event", "Rapture!")
		end
	end,
	
	ExtraDebugInfo = function()
		return string.format("%.1f %s", a.Mana, tostring(a.HealingNeeded))
	end,
}
