local addonName, a = ...
local L = a.Localize
local s = SpellFlashAddon
local c = BittensGlobalTables.GetTable("BittensSpellFlashLibrary")

local GetTime = GetTime
local UnitStat = UnitStat
local select = select

c.RegisterForFullChannels("Penance", 2)

c.AddOptionalSpell("Power Word: Fortitude", nil, {
    NoRangeCheck = true,
    CheckFirst = function()
        return c.RaidBuffNeeded(c.STAMINA_BUFFS)
    end
})

c.AddOptionalSpell("Inner Fire", nil, {
    Buff = "Inner Fire",
    BuffUnit = "player",
})

c.AddOptionalSpell("Power Word: Shield", nil, {
	Override = function(z)
		local now = GetTime()
		if not a.Conserve
			or now - a.LastRapture < 12
			or now - a.ShieldSeen < 2 then
			
			return false
		end
		
		local manaReturn = 1.5 * select(2, UnitStat("player", 5))
		return manaReturn > c.GetCost("Power Word: Shield")
	end
})

c.AddOptionalSpell("Shadowfiend", nil, {
	CheckFirst = function(z)
--		c.MakeMini(z, a.HealingNeeded)
		return a.Mana < 76
	end
})

c.AddOptionalSpell("Mindbender", nil, {
	CheckFirst = function(z)
--		c.MakeMini(z, a.HealingNeeded)
		return a.Mana < 85
	end
})

c.AddOptionalSpell("Desperate Prayer", nil, {
	NoGCD = true,
	Override = function()
		return c.GetHealthPercent("player") < 70
			and c.GetCooldown("Desperate Prayer") == 0
	end
})

c.AddDispel("Dispel Magic", nil, "Magic")

c.AddOptionalSpell("Power Infusion", nil, { 
	NoRangeCheck = true, 
	NoGCD = true,
	CheckFirst = function()
		return c.GetCastTime("Smite") > 1.2
	end,
})

c.AddSpell("Penance", nil, {
	Cooldown = 9,
	RunFirst = function(z)
		z.CanCastWhileMoving = c.HasGlyph("Penance")
	end,
})

c.AddSpell("Holy Fire", nil, {
	FlashID = { "Power Word: Solace", "Holy Fire" },
	Cooldown = 10,
	CheckFirst = function()
		return not c.HasTalent("Solace and Insanity")
	end
})

c.AddSpell("Power Word: Solace", nil, {
	FlashID = { "Power Word: Solace", "Holy Fire" },
	Cooldown = 10,
})

c.AddOptionalSpell("Divine Star", nil, {
	NoRangeCheck = true,
	Cooldown = 15,
	CheckFirst = function(z)
		if c.DistanceAtTheMost() > 24 then
			z.FlashColor = "red"
		else
			z.FlashColor = "yellow"
		end
		return not a.HealingNeeded or not c.IsSolo()
	end
})

c.AddSpell("Smite", nil, {
	CheckFirst = function()
		local cast = c.GetCastTime("Smite")
		if a.HealingNeeded or not a.ConservePercent or c.IsSolo() then
			return true
		elseif a.Neutral then
			return false
		elseif not c.HasGlyph("Smite") 
			or c.GetBuffDuration("Power Infusion") > cast then
			
			return true
		else
			local dot = 
				c.HasTalent("Solace and Insanity") 
					and "Power Word: Solace" 
					or "Holy Fire"
			return c.GetMyDebuffDuration(dot, false, false, true) > cast
		end
	end
})

c.AddOptionalSpell("Shadow Word: Pain", "Apply", {
    MyDebuff = "Shadow Word: Pain",
    CheckFirst = function()
    	return not a.HealingNeeded
    end,
})

c.AddOptionalSpell("Shadow Word: Pain", "Refresh", {
    MyDebuff = "Shadow Word: Pain",
    Tick = 3,
    CheckFirst = function()
    	return not a.HealingNeeded
    end,
})

c.AddOptionalSpell("Shadow Word: Death", nil, {
	Cooldown = 8,
    CheckFirst = function()
        return not a.HealingNeeded and s.HealthPercent() < 20
    end
})

c.AddSpell("Cascade", nil, {
	Cooldown = 25,
	CheckFirst = function(z)
		return not a.HealingNeeded
	end
})
